#$ -S /usr/local/bin/tcsh
set clobber
echo "Running on HOST " $HOST 
set MODE = $CMTCONFIG
set WORKDIR = $PWD
set NEV = 1000
set FIRSTEV = 1
set NEXP = 5
set OPTSFILE = '../options/RunAlignT2VeloFromDST.opts'
set JOBID = 0 
echo "--------------------------------------------------"
echo "Number of Events per Experiment = " $NEV 
echo "First Event in Processing = " $FIRSTEV
echo "Number of Experiments = " $NEXP 
echo "Options File = " $OPTSFILE
echo "Job Identifier = "  $JOBID
echo "--------------------------------------------------" 
#
echo "==> Setting up the Environment:"
setenv User_release_area ~/cmtuser 
SetupProject Alignment v2r0
source ~/cmtuser/Alignment_v2r0/AlignT2Velo/v1r0/cmt/setup.csh 
cd $WORKDIR 
mkdir python
mkdir options
#
echo "===> Updating the CMTPROJECTPATH to:" $CMTPROJECTPATH
setenv CMTPROJECTPATH ${WORKDIR}:$CMTPROJECTPATH
#
echo "==> Copying Database Files to local area:" 
cp --reply=yes $SQLDDDBROOT/db/DDDB.db python/ 
cp --reply=yes $SQLDDDBROOT/db/LHCBCOND.db python/ 
#
echo "==> Copying scripts to local directory:" 
cp --reply=yes $ALIGNT2VELOROOT/python/*.py python/ 
cp --reply=yes ${OPTSFILE} options/
cd python
# 
echo "==> Running the job:" 
# ===> Batch mode
###python AlignT2Velo.py -n $NEV -s $NEXP -o $OPTSFILE >& AlignT2Velo_$NEV.log
# Local mode (default)
time python AlignT2Velo.py -n $NEV -s $NEXP -o $OPTSFILE 
echo "==> Deleting the local Databases"
rm -f *.db
echo "==> Job finished" 
exit 0 
